commit 1d5819935651d3e30bcfede1650ae403e5d20e2e
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Sun May 8 23:15:19 2022 +0200

    Introduce ObjectSignature that can incorporate 192-bit signatures (for 5x5x5 bandaged cubes).
    ObjectScrambler does not fully work yet.

diff --git a/src/main/java/org/distorted/objectlib/helpers/ObjectSignature.java b/src/main/java/org/distorted/objectlib/helpers/ObjectSignature.java
new file mode 100644
index 00000000..bfa487a9
--- /dev/null
+++ b/src/main/java/org/distorted/objectlib/helpers/ObjectSignature.java
@@ -0,0 +1,476 @@
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Copyright 2022 Leszek Koltunski                                                               //
+//                                                                                               //
+// This file is part of Magic Cube.                                                              //
+//                                                                                               //
+// Magic Cube is free software: you can redistribute it and/or modify                            //
+// it under the terms of the GNU General Public License as published by                          //
+// the Free Software Foundation, either version 2 of the License, or                             //
+// (at your option) any later version.                                                           //
+//                                                                                               //
+// Magic Cube is distributed in the hope that it will be useful,                                 //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of                                //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                 //
+// GNU General Public License for more details.                                                  //
+//                                                                                               //
+// You should have received a copy of the GNU General Public License                             //
+// along with Magic Cube.  If not, see <http://www.gnu.org/licenses/>.                           //
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+package org.distorted.objectlib.helpers;
+
+import org.distorted.objectlib.main.ObjectType;
+
+import java.util.ArrayList;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+public class ObjectSignature
+{
+  private long mSignature1, mSignature2, mSignature3;
+  private int[] mLayer;
+  private float[][][] mAllCycles;
+  private float[][] mCubitTouch;
+  private int mNumCubitTouches, mNumCycles;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// built-in objects
+
+  public ObjectSignature(ObjectType type)
+    {
+    mSignature1 = 0;
+    mSignature2 = 0;
+    mSignature3 = type.ordinal();
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectSignature(ObjectSignature sig)
+    {
+    mSignature1 = sig.mSignature1;
+    mSignature2 = sig.mSignature2;
+    mSignature3 = sig.mSignature3;
+
+    mLayer      = sig.mLayer;
+    mAllCycles  = sig.mAllCycles;
+    mCubitTouch = sig.mCubitTouch;
+
+    mNumCycles       = sig.mNumCycles;
+    mNumCubitTouches = sig.mNumCubitTouches;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// built-in bandaged 3x3s; objects created from JSON (version1)
+
+  public ObjectSignature(long signature)
+    {
+    mSignature1 = 0;
+    mSignature2 = 0;
+    mSignature3 = signature;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// objects created from JSON (version2)
+
+  public ObjectSignature(long signature1, long signature2, long signature3)
+    {
+    mSignature1 = signature1;
+    mSignature2 = signature2;
+    mSignature3 = signature3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Locally created bandaged cuboids 1<=N,M,K<=5
+// This is the 'Andreas signature' of a bandaged cube.
+// https://twistypuzzles.com/forum/viewtopic.php?p=415466#p415466
+
+  public ObjectSignature(int lenx, int leny, int lenz, float[][] position)
+    {
+    mLayer = new int[] {lenx,leny,lenz};
+
+    prepareCubitTouch();
+    prepareAllCycles();
+
+    for(float[] pos : position)
+      {
+      int numCenters = pos.length/3;
+
+      for(int i=0; i<numCenters; i++)
+        for(int j=i+1; j<numCenters; j++)
+          {
+          float x1 = pos[3*i  ];
+          float y1 = pos[3*i+1];
+          float z1 = pos[3*i+2];
+          float x2 = pos[3*i  ];
+          float y2 = pos[3*i+1];
+          float z2 = pos[3*i+2];
+
+          if(areNeighbours(x1-x2,y1-y2,z1-z2))
+            {
+            float xc = (x1+y1)/2;
+            float yc = (y1+y2)/2;
+            float zc = (z1+z2)/2;
+
+            int bitIndex = getIndexOfCubitTouch(xc,yc,zc);
+            setBit(bitIndex,1);
+            }
+          }
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public void setSignature(ObjectSignature sig)
+    {
+    mSignature1 = sig.mSignature1;
+    mSignature2 = sig.mSignature2;
+    mSignature3 = sig.mSignature3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public void setSignature(int sig)
+    {
+    mSignature1 = 0;
+    mSignature2 = 0;
+    mSignature3 = sig;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public boolean isEqual(ObjectSignature sig)
+    {
+    return mSignature1==sig.mSignature1 && mSignature2==sig.mSignature2 && mSignature3==sig.mSignature3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public long getLong1()
+    {
+    return mSignature1;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public long getLong2()
+    {
+    return mSignature2;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public long getLong3()
+    {
+    return mSignature3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public String getString()
+    {
+    return mSignature1+"_"+mSignature2+"_"+mSignature3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public boolean isUnblockedFromLeft(int axis, int layer)
+    {
+    if(layer>0)
+      for(int index=0; index<mNumCubitTouches; index++)
+        if( getBit(index)!=0 )
+          {
+          float[] touch = getCubitTouchOfIndex(index);
+          if( belongsToTheLeft(touch,axis,layer) ) return false;
+          }
+
+    return true;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectSignature turn(int axis, int layer, int turn)
+    {
+    ObjectSignature ret = new ObjectSignature(this);
+
+    for(int i=0; i<mNumCycles; i++)
+      {
+      float[][] cyc = mAllCycles[i];
+      float[] p0 = cyc[0];
+      float[] p1 = cyc[1];
+
+      if( (belongsToTheLeft(p0,axis,layer) && belongsToTheLeft(p1,axis,layer)) ||
+          (belongsToTheCent(p0,axis,layer) && belongsToTheCent(p1,axis,layer))  )
+        {
+        ret.cycle(turn,cyc);
+        }
+      }
+
+    return ret;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void cycle(int turn, float[][] cyc)
+    {
+    int numPoints = cyc.length;
+
+    if( numPoints==2 )
+      {
+      float[] p0 = cyc[0];
+      float[] p1 = cyc[1];
+
+      int index0 = getIndexOfCubitTouch(p0[0],p0[1],p0[2]);
+      int index1 = getIndexOfCubitTouch(p1[0],p1[1],p1[2]);
+
+      long b0 = getBit(index0);
+      long b1 = getBit(index1);
+
+      setBit(index1,b0);
+      setBit(index0,b1);
+      }
+    else if( numPoints==4 )
+      {
+      float[] p0 = cyc[0];
+      float[] p1 = cyc[1];
+      float[] p2 = cyc[2];
+      float[] p3 = cyc[3];
+
+      int index0 = getIndexOfCubitTouch(p0[0],p0[1],p0[2]);
+      int index1 = getIndexOfCubitTouch(p1[0],p1[1],p1[2]);
+      int index2 = getIndexOfCubitTouch(p2[0],p2[1],p2[2]);
+      int index3 = getIndexOfCubitTouch(p3[0],p3[1],p3[2]);
+
+      long b0 = getBit(index0);
+      long b1 = getBit(index1);
+      long b2 = getBit(index2);
+      long b3 = getBit(index3);
+
+      switch(turn)
+        {
+        case 1: setBit(index0,b3);
+                setBit(index1,b0);
+                setBit(index2,b1);
+                setBit(index3,b2);
+                break;
+        case 2: setBit(index0,b2);
+                setBit(index1,b3);
+                setBit(index2,b0);
+                setBit(index3,b1);
+                break;
+        case 3: setBit(index0,b1);
+                setBit(index1,b2);
+                setBit(index2,b3);
+                setBit(index3,b0);
+                break;
+        }
+      }
+    else
+      {
+      android.util.Log.e("D", "error in cycle, numPoints="+numPoints);
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void prepareCubitTouch()
+    {
+    int numCenters = mLayer[0]*mLayer[1]*mLayer[2];
+    if( mLayer[0]>1 && mLayer[1]>1 && mLayer[2]>1 ) numCenters -= (mLayer[0]-2)*(mLayer[1]-2)*(mLayer[2]-2);
+
+    float[][] centers = new float[numCenters][];
+    int index = 0;
+
+    for(int i = 0; i<mLayer[0]; i++)
+      for(int j = 0; j<mLayer[1]; j++)
+        for(int k = 0; k<mLayer[2]; k++)
+          if( (i==0) || (i==mLayer[0]-1) || (j==0) || (j==mLayer[1]-1) || (k==0) || (k==mLayer[2]-1) )
+            {
+            centers[index++] = new float[] { i+0.5f*(1-mLayer[0]), j+0.5f*(1-mLayer[1]), k+0.5f*(1-mLayer[2]) };
+            }
+
+    ArrayList<float[]> mTouch = new ArrayList<>();
+
+    for(int i=0; i<numCenters; i++)
+      for(int j=i+1; j<numCenters; j++)
+        {
+        float[] c0 = centers[i];
+        float[] c1 = centers[j];
+
+        float x1 = c0[0];
+        float y1 = c0[1];
+        float z1 = c0[2];
+        float x2 = c1[0];
+        float y2 = c1[1];
+        float z2 = c1[2];
+
+        if( areNeighbours(x1-x2,y1-y2,z1-z2) )
+          {
+          float xc = (x1+y1)/2;
+          float yc = (y1+y2)/2;
+          float zc = (z1+z2)/2;
+
+          float[] touch = new float[] {xc,yc,zc};
+          mTouch.add(touch);
+          }
+        }
+
+    mNumCubitTouches = mTouch.size();
+    mCubitTouch = new float[mNumCubitTouches][];
+    for(int i=0; i<mNumCubitTouches; i++) mCubitTouch[i] = mTouch.remove(0);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void prepareAllCycles()
+    {
+    ArrayList<float[][]> cycles = new ArrayList<>();
+
+    boolean[] longTurn = new boolean[] { mLayer[1]==mLayer[2], mLayer[0]==mLayer[2], mLayer[0]==mLayer[1] };
+
+    for(int i=0; i<mNumCubitTouches; i++)
+      for(int axis=0; axis<3; axis++)
+        {
+        if( longTurn[axis] )
+          {
+          int i0 = rotateIndex(axis,i);
+          if( i0<i ) continue;
+          int i1 = rotateIndex(axis,i0);
+          if( i1<i ) continue;
+          int i2 = rotateIndex(axis,i1);
+          if( i2<i ) continue;
+
+          float[] f0 = getCubitTouchOfIndex(i);
+          float[] f1 = getCubitTouchOfIndex(i0);
+          float[] f2 = getCubitTouchOfIndex(i1);
+          float[] f3 = getCubitTouchOfIndex(i2);
+
+          float[][] cycle = new float[][] { f0,f1,f2,f3 };
+          cycles.add(cycle);
+          }
+        else
+          {
+          int i0 = rotateIndex2(axis,i);
+          if( i0<i ) continue;
+
+          float[] f0 = getCubitTouchOfIndex(i);
+          float[] f1 = getCubitTouchOfIndex(i0);
+
+          float[][] cycle = new float[][] { f0,f1 };
+          cycles.add(cycle);
+          }
+        }
+
+    mNumCycles = cycles.size();
+    mAllCycles = new float[mNumCycles][][];
+    for(int i=0; i<mNumCycles; i++) mAllCycles[i] = cycles.remove(0);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private int rotateIndex(int axis, int index)
+    {
+    float[] touch = getCubitTouchOfIndex(index);
+
+    switch(axis)
+      {
+      case 0: return getIndexOfCubitTouch(+touch[0],+touch[2],-touch[1]);
+      case 1: return getIndexOfCubitTouch(-touch[2],+touch[1],+touch[0]);
+      case 2: return getIndexOfCubitTouch(+touch[1],-touch[0],+touch[2]);
+      }
+
+    return -1;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private int rotateIndex2(int axis, int index)
+    {
+    float[] touch = getCubitTouchOfIndex(index);
+
+    switch(axis)
+      {
+      case 0: return getIndexOfCubitTouch(+touch[0],-touch[1],-touch[2]);
+      case 1: return getIndexOfCubitTouch(-touch[0],+touch[1],-touch[2]);
+      case 2: return getIndexOfCubitTouch(-touch[0],-touch[1],+touch[2]);
+      }
+
+    return -1;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private boolean belongsToTheLeft(float[] point, int axis, int layer)
+    {
+    return 2*point[axis]+mLayer[axis] == 2*layer;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private boolean belongsToTheCent(float[] point, int axis, int layer)
+    {
+    return 2*point[axis]+mLayer[axis] == 2*layer+1;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private int getIndexOfCubitTouch(float x, float y, float z)
+    {
+    for(int i=0; i<mNumCubitTouches; i++)
+      {
+      float[] touch = mCubitTouch[i];
+      if( touch[0]==x && touch[1]==y && touch[2]==z ) return i;
+      }
+
+    return -1;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private float[] getCubitTouchOfIndex(int index)
+    {
+    return mCubitTouch[index];
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private boolean areNeighbours(float dx, float dy, float dz)
+    {
+    return dx*dx+dy*dy+dz*dz<1.1f;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private long getBit(int index)
+    {
+    switch(index/64)
+      {
+      case 0: return (mSignature3>>(index%64))&0x1;
+      case 1: return (mSignature2>>(index%64))&0x1;
+      case 2: return (mSignature1>>(index%64))&0x1;
+      default: android.util.Log.e("D", "error in getBit, index="+index);
+      }
+
+    return 0L;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void setBit(int index, long bit)
+    {
+    long diff = (1L<<(index%64));
+
+    switch(index/64)
+      {
+      case 0: if( bit!=0 ) mSignature3 |= diff;
+              else         mSignature3 &=~diff;
+              break;
+      case 1: if( bit!=0 ) mSignature2 |= diff;
+              else         mSignature2 &=~diff;
+              break;
+      case 2: if( bit!=0 ) mSignature1 |= diff;
+              else         mSignature1 &=~diff;
+              break;
+      default: android.util.Log.e("D", "error in setBit, index="+index);
+      }
+    }
+}
diff --git a/src/main/java/org/distorted/objectlib/json/JsonReader.java b/src/main/java/org/distorted/objectlib/json/JsonReader.java
index 59dc7025..54be8379 100644
--- a/src/main/java/org/distorted/objectlib/json/JsonReader.java
+++ b/src/main/java/org/distorted/objectlib/json/JsonReader.java
@@ -31,6 +31,7 @@ import java.nio.charset.StandardCharsets;
 import android.content.Context;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.json.JSONArray;
 import org.json.JSONException;
 import org.json.JSONObject;
@@ -78,7 +79,7 @@ public class JsonReader
   private boolean mResetMaps;
   private String mTutorialObject;
   private String[][] mTutorials;
-  private long mSignature;
+  private ObjectSignature mSignature;
 
   private static JsonReader mThis;
 
@@ -98,7 +99,7 @@ public class JsonReader
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  private void parseMetadata(JSONObject object) throws JSONException
+  private void parseMetadata1(JSONObject object) throws JSONException
     {
     mLongName        = object.getString("longname");
     mShortName       = object.getString("shortname");
@@ -112,13 +113,43 @@ public class JsonReader
 
     try
       {
-      mSignature = object.getLong("signature");
+      long signature = object.getLong("signature");
+      mSignature = new ObjectSignature(signature);
       }
     catch(JSONException ex)
       {
       // objects older than Feb 2022 do not have the 'signature' field. They all use the ObjectType.ordinal
       // as their signature.
-      mSignature = ObjectType.getOrdinal(mShortName);
+      long signature = ObjectType.getOrdinal(mShortName);
+      mSignature = new ObjectSignature(signature);
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void parseMetadata2(JSONObject object) throws JSONException
+    {
+    mLongName        = object.getString("longname");
+    mShortName       = object.getString("shortname");
+    mInventor        = object.getString("inventor");
+    mYearOfInvention = object.getInt("year");
+    mComplexity      = object.getInt("complexity");
+    mSize            = (float)object.getDouble("size");
+    mNumScrambles    = object.getInt("scrambles");
+    mResetMaps       = object.getBoolean("resetmaps");
+    mNumFaces        = object.getInt("num_faces");
+
+    try
+      {
+      long signature1 = object.getLong("signature1");
+      long signature2 = object.getLong("signature2");
+      long signature3 = object.getLong("signature3");
+      mSignature = new ObjectSignature(signature1,signature2,signature3);
+      }
+    catch(JSONException ex)
+      {
+      long signature = object.getLong("signature");
+      mSignature = new ObjectSignature(signature);
       }
     }
 
@@ -554,7 +585,7 @@ public class JsonReader
   private void parseVersion1(JSONObject object) throws JSONException
     {
     JSONObject metadata    = object.getJSONObject("metadata");
-    parseMetadata(metadata);
+    parseMetadata1(metadata);
     JSONObject mesh        = object.getJSONObject("mesh");
     parseMesh(mesh);
     JSONArray axis         = object.getJSONArray("axis");
@@ -576,7 +607,7 @@ public class JsonReader
   private void parseVersion2(JSONObject object) throws JSONException
     {
     JSONObject metadata    = object.getJSONObject("metadata");
-    parseMetadata(metadata);
+    parseMetadata2(metadata);
     JSONObject mesh        = object.getJSONObject("mesh");
     parseMesh(mesh);
     JSONArray axis         = object.getJSONArray("axis");
@@ -615,10 +646,18 @@ public class JsonReader
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  private void parseVersion1or2Metadata(JSONObject object) throws JSONException
+  private void parseVersion1Metadata(JSONObject object) throws JSONException
+    {
+    JSONObject metadata = object.getJSONObject("metadata");
+    parseMetadata1(metadata);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void parseVersion2Metadata(JSONObject object) throws JSONException
     {
     JSONObject metadata = object.getJSONObject("metadata");
-    parseMetadata(metadata);
+    parseMetadata2(metadata);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -678,9 +717,13 @@ public class JsonReader
       JSONObject object = new JSONObject(contents.toString());
       int major = object.getInt("major");
 
-      if( major==1 || major==2 )
+      if( major==1 )
+        {
+        parseVersion1Metadata(object);
+        }
+      else if( major==2 )
         {
-        parseVersion1or2Metadata(object);
+        parseVersion2Metadata(object);
         }
       else
         {
@@ -951,7 +994,7 @@ public class JsonReader
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     return mSignature;
     }
diff --git a/src/main/java/org/distorted/objectlib/json/JsonWriter.java b/src/main/java/org/distorted/objectlib/json/JsonWriter.java
index ff0081b4..6780caf6 100644
--- a/src/main/java/org/distorted/objectlib/json/JsonWriter.java
+++ b/src/main/java/org/distorted/objectlib/json/JsonWriter.java
@@ -26,6 +26,7 @@ import java.io.OutputStreamWriter;
 import java.nio.charset.StandardCharsets;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.json.JSONArray;
 import org.json.JSONException;
 import org.json.JSONObject;
@@ -362,7 +363,12 @@ public class JsonWriter
     metadata.put("shortname"  , object.getShortName() );
     metadata.put("resetmaps"  , object.shouldResetTextureMaps() );
     metadata.put("num_faces"  , object.getNumFaces() );
-    metadata.put("signature"  , object.getSignature() );
+
+    ObjectSignature signature = object.getSignature();
+
+    metadata.put("signature1" , signature.getLong1() );
+    metadata.put("signature2" , signature.getLong2() );
+    metadata.put("signature3" , signature.getLong3() );
 
     return metadata;
     }
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyJson.java b/src/main/java/org/distorted/objectlib/main/TwistyJson.java
index 8ff8b57c..629e919e 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyJson.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyJson.java
@@ -25,6 +25,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.scrambling.ScrambleState;
 import org.distorted.objectlib.json.JsonReader;
@@ -284,7 +285,7 @@ public class TwistyJson extends TwistyObject
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     return mReader.getSignature();
     }
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObject.java b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
index 0b6fb9b7..5981fb1d 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObject.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
@@ -54,6 +54,7 @@ import org.distorted.objectlib.helpers.FactorySticker;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectLibInterface;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.QuatGroupGenerator;
 import org.distorted.objectlib.scrambling.ScrambleState;
@@ -1749,7 +1750,7 @@ public abstract class TwistyObject
   public abstract float getScreenRatio();
   public abstract int getColor(int face);
   public abstract String getShortName();
-  public abstract long getSignature();
+  public abstract ObjectSignature getSignature();
 
   // not only for JSON
   public abstract Static3D[] getRotationAxis();
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyAxis.java b/src/main/java/org/distorted/objectlib/objects/TwistyAxis.java
index 4c7ffd69..06b6fd29 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyAxis.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyAxis.java
@@ -23,6 +23,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.scrambling.ScrambleState;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.main.ShapeHexahedron;
@@ -490,9 +491,9 @@ public class TwistyAxis extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.AXIS_3.ordinal();
+    return new ObjectSignature(ObjectType.AXIS_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
index aa73f575..a5b38fb0 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
@@ -24,6 +24,7 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -79,6 +80,13 @@ public class TwistyBandaged2Bar extends TwistyBandagedAbstract
     return ObjectType.BAN2_3.name();
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectSignature getSignature()
+    {
+    return new ObjectSignature(ObjectType.BAN2_3);
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public String getObjectName()
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
index c379cf34..d4a527f4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
@@ -24,6 +24,7 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -73,6 +74,13 @@ public class TwistyBandaged3Plate extends TwistyBandagedAbstract
     return ObjectType.BAN3_3.name();
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectSignature getSignature()
+    {
+    return new ObjectSignature(ObjectType.BAN3_3);
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public String getObjectName()
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
index 90f232f7..c6f08b9a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
@@ -30,7 +30,8 @@ import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.FactoryBandagedCubit;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
-import org.distorted.objectlib.scrambling.ScrambleStateBandagedCuboid;
+import org.distorted.objectlib.helpers.ObjectSignature;
+import org.distorted.objectlib.scrambling.ScrambleStateBandaged3x3;
 import org.distorted.objectlib.touchcontrol.TouchControlHexahedron;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.scrambling.ScrambleState;
@@ -191,14 +192,25 @@ abstract class TwistyBandagedAbstract extends ShapeHexahedron
     return mSolvedQuatsAbstract;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectSignature getSignature()
+    {
+    long signature = 0;
+    float[][] positions = getPositions();
+    for(float[] pos : positions ) signature = markConnections(signature,pos);
+
+    return new ObjectSignature(signature);
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public ScrambleState[] getScrambleStates()
     {
     if( mStates==null && !isInIconMode() )
       {
-      long signature = getSignature();
-      mStates = ScrambleStateBandagedCuboid.computeGraph(signature);
+      ObjectSignature signature = getSignature();
+      mStates = ScrambleStateBandaged3x3.computeGraph(signature.getLong3());
       }
 
     return mStates;
@@ -382,16 +394,6 @@ abstract class TwistyBandagedAbstract extends ShapeHexahedron
     return signature;
     }
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public long getSignature()
-    {
-    long signature = 0;
-    float[][] positions = getPositions();
-    for(float[] pos : positions ) signature = markConnections(signature,pos);
-    return signature;
-    }
-
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public ObjectShape getObjectShape(int variant)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedBiCube.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedBiCube.java
index 19631562..aacf5b5b 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedBiCube.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedBiCube.java
@@ -24,6 +24,7 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -69,6 +70,13 @@ public class TwistyBandagedBiCube extends TwistyBandagedAbstract
     return ObjectType.BAN4_3.name();
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectSignature getSignature()
+    {
+    return new ObjectSignature(ObjectType.BAN4_3);
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public String getObjectName()
